<?php

/**
 * @file
 * Drupal proxy script. This file must be copied to the drupal install folder.
 */

ini_set('display_errors', FALSE);

require_once('./includes/bootstrap.inc');

$params = $_GET;
$url = isset($params['url']) ? $params['url'] : '';
if (empty($url)) {
  echo "Url missing";
  exit();
}

unset($params['url']);
$ch = strpos($url, '?') == FALSE ? '?' : (substr($url, -1) == '&' ? '' : '&');
foreach ($params as $key => $value) {
  $url .= "{$ch}$key=" . urlencode($value);
  $ch = '&';
}

// Minimum load of components.
drupal_bootstrap(DRUPAL_BOOTSTRAP_CONFIGURATION);

//global $user;

//require_once './includes/install.inc';
require_once './includes/common.inc';
//require_once './modules/system/system.install';

/*
// Load module basics.
include_once './includes/module.inc';
$module_list['system']['filename'] = 'modules/system/system.module';
$module_list['filter']['filename'] = 'modules/filter/filter.module';
module_list(TRUE, FALSE, FALSE, $module_list);
drupal_load('module', 'system');
drupal_load('module', 'filter');
*/

// Proxy request should pass on cookie headers to prevent Drupal from
// ending a session. Note: only if same host as this site!
$headers = array();
if (!empty($_COOKIE) && $_SERVER['HTTP_HOST'] == parse_url($url, PHP_URL_HOST)) {
  $cookies = ''; $ch = '';
  foreach ($_COOKIE as $key => $value) {
    $cookies .= $ch . $key . '=' . $value;
    $ch = '; ';
  }
  $headers['Cookie'] = $cookies;
}

$response = drupal_http_request($url, $headers);
if ($response->error) {
  header('HTTP/1.1 404 Not Found');
  echo var_export($response, true);
}
else {
  if (isset($response->headers)) {
    foreach ($response->headers as $key => $value) {
      drupal_set_header("$key: $value");
    }
  }
  echo $response->data;
}
exit();

