<?php
/**
 * @file
 * Browse geodata.
 */

/**
 * Browse geodata.
 */
function geodata_browse($node) {
  //return var_export($node, TRUE);
  //ini_set('max_execution_time', 60); // todo: check present value
  $per_page = 20;
  $show_geom = FALSE;
  
  if ($node->geodata_type == GEODATA_IMPORT_SHAPEFILE) {
    $output = t('Browsing not supported for shapefiles.');
    return $output;
  }
  
  // alles
  $sql = "SELECT *, astext({$node->geometry_column}) as {$node->geometry_column} from {$node->data_path} t";
  // geen aparte count_query nodig
  $count_query = NULL;
  // count query
  $count_query = "select count(*) as count_query from {$node->data_path}";
  
  $cache = cache_get("geodata:{$node->vid}:header");
  //$cache = 0;
  //drupal_set_message('cache:'. var_export($cache, TRUE));
  // try to get header from cache
  if ($cache !== 0 && is_array($cache->data)) {
    $header = $cache->data;
    //drupal_set_message(var_export($header, TRUE));
  }
  else {
    $header = NULL;
    //drupal_set_message('niet in cache');
  }
  
  $prev_db = db_set_active($node->database_name);
  if (isset($header)) {
    $sql .= tablesort_sql($header);
  }
  $result = pager_query($sql, $per_page, 0, $count_query);
  
  $rows = array();
  while ($rec = db_fetch_array($result)) {
    if (! isset($header)) {
      $header = array();
      foreach (array_keys($rec) as $field) {
        $header[] = array('data' => $field, 'field' => $field);
      }
    }
    
    if (!$show_geom) {
      unset($rec[$node->geometry_column]);
    }
    $rows[] = array_values($rec);
  }
  db_set_active($prev_db);
  
  cache_set("geodata:{$node->vid}:header", $header);
  
  if (!$show_geom) {
    for ($i = 0; $i < count($header); $i++) {
      if ($header[$i]['field'] == $node->geometry_column) {
        array_splice($header, $i, 1);
        break;
      }
    }
  }
  
  $output = '';
  $output .= theme('table', $header, $rows);
  $output .= theme('pager', NULL, $per_page);
  return $output;
}

