<?php

function _geodata_add_google_projection($database) {
  
  // define google projection for database (if not yet present)
  if (db_set_active($database)) {
    if (! db_table_exists('spatial_ref_sys')) {
      drupal_set_message(t('The geodata module must use a postgis enabled database. Please goto !link.', array('!link' => l('Geodata settings', 'admin/mappingkit/geodata'))), 'error');
    }
    else {
      db_query("INSERT into spatial_ref_sys (srid, auth_name, auth_srid, proj4text, srtext) select 900913, 'spatialreference.org', 900913
        , '+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +wktext  +no_defs'
        , 'PROJCS[\"unnamed\",GEOGCS[\"unnamed ellipse\",DATUM[\"unknown\",SPHEROID[\"unnamed\",6378137,0]],PRIMEM[\"Greenwich\",0],UNIT[\"degree\",0.0174532925199433]],PROJECTION[\"Mercator_2SP\"],PARAMETER[\"standard_parallel_1\",0],PARAMETER[\"central_meridian\",0],PARAMETER[\"false_easting\",0],PARAMETER[\"false_northing\",0],UNIT[\"Meter\",1],EXTENSION[\"PROJ4\",\"+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +wktext  +no_defs\"]]'
        where 0 = (select count(*) from spatial_ref_sys where srid = 900913)"); // \''
      $affected_rows = db_affected_rows();
      db_set_active();
      
      if ($affected_rows > 0) {
        drupal_set_message(t('Google projection has been added to spatial_ref_sys table'));
      }
      else {
        // Google projection was already defined in spatial_ref_sys table
      }
    }
  }
  else {
    drupal_set_message(t('Error setting active database to %name'
      , array('%name' => $database)), 'error');
  }
}


