<?php
/**
 * @file
 * Mappingkit logger.
 */

class Logger {
  const LOG_UNKNOWN = -1;
  const LOG_OFF = 0;
  const LOG_NONE = 0;
  const LOG_FATAL = 1;
  const LOG_ERROR = 2;
  const LOG_WARN = 4;
  const LOG_INFO = 8;
  const LOG_DEBUG = 16;
  
  private $level;
  
  function Logger() {
    if (isset($_SESSION['log'])) {
      $this->set_level($_SESSION['log']);
    }
    else {
      $level = Logger::LOG_NONE;
    }
  }
  
  function set_level($str = NULL) {
    drupal_set_message('Logging is set to '. $str);
    if (is_null($str)) {
      $this->level = Logger::LOG_NONE;
    }
    else {
      $levels = array(NULL => Logger::LOG_NONE, 'none' => Logger::LOG_NONE, 'debug' => Logger::LOG_DEBUG, 'info' => Logger::LOG_INFO);
      $this->level = $levels[$str];
    }
  }
  
  function debug($str, $vars = NULL) {
    if ($this->level >= Logger::LOG_DEBUG) {
      drupal_set_message($str . (is_null($vars) ? '' : (' '. var_export($vars, TRUE))));
    }
  }
  
  function info($str, $vars = NULL) {
    if ($this->level >= Logger::LOG_INFO) {
      drupal_set_message($str . (is_null($vars) ? '' : (' '. var_export($vars, TRUE))));
    }
  }
  
  function warn($str) {
    if ($this->level >= Logger::LOG_WARN) {
      drupal_set_message($str, 'error');
    }
  }
  
  function log($level, $str) {
    switch ($level) {
    default:
      break;
    }
  }
}

global $_mappingkit_logger;
$_mappingkit_logger = new Logger();

if (!isset($_GET['log'])) {
  // check the logging setting
  switch (variable_get('mappingkit_logging', Logger::LOG_UNKNOWN)) {
  case Logger::LOG_NONE;
    if (isset($_SESSION['log'])) {
      unset($_SESSION['log']);
      $_mappingkit_logger->set_level(NULL);
    }
    break;
  case Logger::LOG_INFO:
    if (!isset($_SESSION['log'])) {
      $_SESSION['log'] = 'info';
      $_mappingkit_logger->set_level('info');
    }
    break;
  case Logger::LOG_DEBUG:
    if (!isset($_SESSION['log'])) {
      $_SESSION['log'] = 'debug';
      $_mappingkit_logger->set_level('debug');
    }
    break;
  }
}
else if (variable_get('mappingkit_logging', Logger::LOG_NONE) != Logger::LOG_NONE
  || $_SERVER['HTTP_HOST'] == 'localhost') {
  // check the url parameter if logging is set or localhost
  if ($_GET['log'] == 'none') {
    $_mappingkit_logger->info('Logging is off');
    unset($_SESSION['log']);
    $_mappingkit_logger->set_level(NULL);
  }
  else {
    $_SESSION['log'] = $_GET['log'];
    $_mappingkit_logger->set_level($_SESSION['log']);
    $_mappingkit_logger->info('Logging is on');
  }
}

//$_mappingkit_logger->info('Een info melding');
//$_mappingkit_logger->debug('Een debug melding');

