
/**
 * 
 */
MappingKit.buildMapTag = function(br_open, br_close) {
  var attrs = '';
  
  // contexts
  var context_el = document.getElementById('edit-contexts');
  if (context_el.value != '') {
    attrs += ' context="' + context_el.value + '"';
  }
  
  // base_layers
  var baselayers = new Array();
  var el = document.getElementById('edit-base-layers-google');
  if (el && el.checked) {
    baselayers[baselayers.length] = 'google';
  }
  el = document.getElementById('edit-base-layers-ve');
  if (el && el.checked) {
    baselayers[baselayers.length] = 've';
  }
  el = document.getElementById('edit-base-layers-yahoo');
  if (el && el.checked) {
    baselayers[baselayers.length] = 'yahoo';
  }
  el = document.getElementById('edit-base-layers-osm');
  if (el && el.checked) {
    baselayers[baselayers.length] = 'osm';
  }
  el = document.getElementById('edit-base-layers-oam');
  if (el && el.checked) {
    baselayers[baselayers.length] = 'oam';
  }
  if (baselayers.length > 0) {
    baselayers[baselayers.length] = 'none';
    attrs += ' baselayers="' + baselayers.join(',') + '"';
  }
  
  // layers
  var el = document.getElementById('edit-layers');
  if (el && el.value != '') {
    var layers = el.value.split('\n');
    var layers_attr = ' layers=';
    var layers_defs = '';
    var sep = '"';
    for (var i = 0; i < layers.length; i++) {
      layers_attr += sep + (i+1);
      sep = ',';
      layers_defs += ' ' + (i+1) + '="' + layers[i] + '"';
    }
    layers_attr += '"';
    attrs += layers_attr + layers_defs;
  }
  
  // extent
  var extent_props = ['minx', 'miny', 'maxx', 'maxy'];
  var extent = [];
  for (var i = 0; i < extent_props.length; i++) {
    var el = document.getElementById('edit-' + extent_props[i]);
    if (el && el.value != '') {
      extent[i] = el.value;
    }
  }
  if (extent.length == 4) {
    attrs += ' extent="' + extent.join(',') + '"';
  }
  
  // size
  var others = ['width', 'height'];
  for (var i = 0; i < others.length; i++) {
    var el = document.getElementById('edit-' + others[i]);
    if (el && el.value != '') {
      attrs += ' ' + others[i] + '="' + el.value + '"';
    }
  }
  
  var maptag_el = document.getElementById('edit-maptag');
  maptag_el.value = br_open + 'map' + attrs + '/' + br_close + '\n';
  
  return true;
}

MappingKit.addLayer = function() {
  var parts = [];
  var el_type = document.getElementById('edit-type');
  if (!el_type || el_type.value == '') {
    alert(Drupal.t('Layer type is required'));
    return;
  }
  parts[parts.length] = el_type.value;
  var el_url = document.getElementById('edit-url');
  if (!el_url || el_url.value == '') {
    alert(Drupal.t('Layer URL is required'));
    return;
  }
  parts[parts.length] = el_url.value;
  var el_title = document.getElementById('edit-title');
  if (el_title && el_title.value != '') {
    parts[parts.length] = el_title.value;
  }
  
  var el = document.getElementById('edit-layers');
  el.value = el.value + ((el.value == '') ? '' : '\n') + parts.join('|');
  el_type.value = el_url.value = el_title.value = '';
}

