<?php
/**
 * @file
 * Administer mapcontexts.
 */

function mapcontext_settings_form() {
  
  $form['demo'] = array(
    '#type' => 'fieldset'
    , '#title' => t('Demo')
    , '#collapsible' => TRUE
    );
  
  $form['demo']['create'] = array('#type' => 'submit'
    , '#value' => t('Create')
    , '#submit' => array('mapcontext_create_demos')
    );
  
  $count = (int)db_result(db_query('select count(*) from {mapcontext}'));
  if ($count == 0) {
    $form['demo']['#description'] = t('No map contexts found. Press the [Create] button to create two demo map contexts.');
  }
  else {
    $form['demo']['#collapsed'] = TRUE;
    $form['demo']['#description'] = t('%count map contexts are already present. Press the [Create] button to create two additional demo map contexts.', array('%count' => $count));
  }
  
  $form['files'] = array(
    '#type' => 'fieldset'
    , '#title' => t('Files')
    , '#description' => t('Map contexts can be written to files in order to increase performance.')
    );
  $form['files']['write'] = array('#type' => 'submit'
    , '#value' => t('Write contexts')
    , '#submit' => array('mapcontext_write_files')
    );
  
  return $form;//system_settings_form($form);
}

function mapcontext_create_demos() {
  global $user;
  
  module_load_include('inc', 'node', 'node.pages');
  
  $form_state = array();
  $form_state['values']['name'] = $user->name;
  $form_state['values']['op'] = t('Save');
  $form_state['values']['title'] = 'Demo baselayers';
  $form_state['values']['body'] = t('This is a map context with several base layers. It can be used as a map context to set user and node locations.');
  $form_state['values']['width'] = 512;
  $form_state['values']['height'] = 256;
  $form_state['values']['srs'] = 'EPSG:4326';
  $form_state['values']['minx'] = -180;
  $form_state['values']['miny'] = -90;
  $form_state['values']['maxx'] = 180;
  $form_state['values']['maxy'] = 90;
  $form_state['values']['baselayers'] = 'google,google-physical,osm,oam,yahoo';
  $form_state['values']['log'] = t('Automatically created by the Map context module.');
  $node = array('type' => 'mapcontext');
  drupal_execute('mapcontext_node_form', $form_state, (object)$node);

  //db_query("insert into {mapcontext}() values()");
  //db_query("insert into {mapcontext_layers} values()");
  
  // (2) Demis world map
  $form_state = array();
  $form_state['values']['name'] = $user->name;
  $form_state['values']['op'] = t('Save');
  $form_state['values']['title'] = 'Demis world map';
  $form_state['values']['body'] = t('This is a map context for the Demis world map. It can be used as a map context to set user and node locations.');
  $form_state['values']['width'] = 512;
  $form_state['values']['height'] = 256;
  $form_state['values']['srs'] = 'EPSG:4326';
  $form_state['values']['minx'] = -180;
  $form_state['values']['miny'] = -90;
  $form_state['values']['maxx'] = 180;
  $form_state['values']['maxy'] = 90;
  $form_state['values']['log'] = t('Automatically created by the Map context module.');
  // layers
  $node = array('type' => 'mapcontext');
  $node['layers'] = array(
    array('seqno' => 1, 'version' => '1.1.1', 'href' => 'http://www2.demis.nl/WMS/wms.asp?wms=WorldMap'
      , 'layer_title' => 'Demis world map', 'baselayer' => 1
      , 'names' => 'Bathymetry,Countries,Topography,Hillshading,Coastlines,Waterbodies,Inundated,Rivers,Streams,Builtup+areas,Railroads,Highways,Roads,Trails,Borders,Cities,Settlements,Airports,Spot+elevations,Ocean+features')
    );
  drupal_execute('mapcontext_node_form', $form_state, (object)$node);
  
  drupal_set_message(t('Two demo map contexts have been created. These can be used as user and node location map contexts for !types or !users.', array('!types' => l('Content types', 'admin/content/types'), '!users' => l('User settings', 'admin/user/settings'))));
}

/**
 * Write map contexts as files.
 * @todo: link to mapcontext admin page
 */
function mapcontext_write_files() {
  module_load_include('inc', 'mapcontext');
  
  // create folder for map contexts
  $path = mapcontext_get_context_path();
  if (! file_exists($path)) {
    $success = @mkdir($path, 0777, TRUE);
    // todo: message?
    if ($success) {
      drupal_set_message(t('Folder %path is created.', array('%path' => $path)));
    }
    else {
      drupal_set_message(t('Failed to create %path.', array('%path' => $path)), 'warning');
      return;
    }
  }
  
  // write xml files for all mapcontexts
  $count = 0;
  $result = db_query("select nid from {node} where type = 'mapcontext'");
  while ($nid = db_result($result)) {
    $node = node_load((int)$nid);
    if ($node) {
      if (! mapcontext_write_xml($node)) {
        drupal_set_message(t('Failed to write file for map context %title', array('%title' => $node->title)), 'warning');
        return;
      }
      $count += 1;
    }
  }
  drupal_set_message(t('%count map contexts were written to %path.', array('%count' => $count, '%path' => $path)));
    //$ret[] = array('success' => $success, 'query' => 'Write map context nodes as xml files in '. $path);
}
