<?php
/**
 * @file
 * Administer maplayers.
 */

function maplayer_settings_form() {
  $form['maplayer'] = array(
    '#type' => 'fieldset'
    , '#title' => t('Map layer')
    , '#collapsible' => TRUE
    );
  
  $vocabularies = taxonomy_get_vocabularies('maplayer');
  $options = array(0 => t('Select a vocabulary'));
  if (count($vocabularies) < 1) {
    drupal_set_message(t('No vocabularies defined for Map layers. Check the node type !link for the vocabularies.', array('!link' => l('settings', 'admin/content/taxonomy'))), 'warning');
  }
  else {
    foreach ($vocabularies as $vid => $voc) {
      $options[$vid] = $voc->name;
    }
  }
  
  $form['maplayer']['maplayer_vocabulary'] = array('#type' => 'select'
    , '#title' => t('Vocabulary')
    , '#default_value' => variable_get('maplayer_vocabulary', 0)
    , '#options' => $options
    , '#description' => t('Select the default vocabulary to be used for characterizing Map Layers. Check the node type !link for the vocabularies.', array('!link' => l('settings', 'admin/content/taxonomy')))
    );
  
  $form['maplayer']['maplayer_map_id'] = array('#type' => 'textfield'
    , '#title' => t('Map ID')
    , '#default_value' => variable_get('maplayer_map_id', 'tree')
    , '#size' => 20
    , '#description' => t('Enter an id for the map that will display the Map layer feeds from the tree view. This id should be used in a &#91;map id="?" /&#93; definition.')
    );
  
  $form['maplayer']['maplayer_max_items'] = array('#type' => 'textfield'
    , '#title' => t('Max. items')
    , '#default_value' => variable_get('maplayer_max_items', 10)
    , '#size' => 10
    , '#description' => t('Enter the maximum number of items in a map layer feed.')
    );
  
  $form['maplayer']['maplayer_persistent_tree'] = array('#type' => 'checkbox'
    , '#title' => t('Persistent tree')
    , '#default_value' => variable_get('maplayer_persistent_tree', 0)
    );
  
  $form['maplayer']['maplayer_default_srs'] = array('#type' => 'textfield'
    , '#title' => t('Default SRS')
    , '#default_value' => variable_get('maplayer_default_srs', '')
    , '#description' => t('Default SRS for map layers. If not empty, a new map layer derived from a WMS will have its projection transformed to this SRS. Note that this does not mean that the WMS supports this SRS when serving images.')
    , '#size' => 12
    );
  
  // todo: add maximum extent/projection for the maplayer feeds
  
  return system_settings_form($form);
}


