
MappingKit.updateMap = function(options) {
  // create map from context by synchronous load
  
  var levels = 'all';
  
  if (options.user) {
    var feed = 'maplayer/' + options.user + '/feed';
  }
  else {
    var terms = options.term;
    if (options.and && options.and != '') {
      terms += ',' + options.and;
    }
    var feed = 'taxonomy/term/' + terms + '/' + levels + '/feed';
  }
  
  var id = options.id ? options.id : 'tree';
  if (!options.checkbox) {
    MappingKit.feedMap(feed, id);
  }
  else if (options.checkbox.checked) {
    MappingKit.feedMap(feed, id);
    // set all sub-checkboxes
    $(options.checkbox).parent().parent().find('div.maplayer-check > input').each(maplayer_check);
  }
  else {
    MappingKit.unfeedMap(feed, id);
    // unset all sub-checkboxes
    $(options.checkbox).parent().parent().find('div.maplayer-check > input').each(maplayer_uncheck);
  }
}

function maplayer_check(i) {
  this.checked = true;
}

function maplayer_uncheck(i) {
  this.checked = false;
}

MappingKit.unfeedMap = function(feed, id) {
  var url = Drupal.settings.basePath + '?q=' + feed;
  var request = new OpenLayers.Ajax.Request(url, {method: 'get', asynchronous: false, parameters: {'q': feed} });
  var text = '';
  if (request && request.transport && request.transport.status == 200) {
    text = request.transport.responseText;
  }
  else {
    alert('Feed ' + feed + ' returned ' + request.transport.statusText + ' (' + request.transport.status + ')');
    return;
  }
  var format = new MappingKit.Format.MapLayerRSS({layerOptions: {isBaseLayer: true, buffer: 0}});
  var layers = format.read(text);
  
  // find map with specific id
  var map = MappingKit.getMap(id);
  if (map) {
    /*
    // remove non-base layers
    for (var i = map.getNumLayers()-1; i > 0; i--) {
      map.removeLayer(map.layers[i]);
    }
    */
    // remove map layers present in feed
    var count_added = 0;
    for (var i = 0; i < layers.length; i++) {
      for (var j = 0; j < map.layers.length; j++) {
        if (map.layers[j].name == layers[i].name
          && map.layers[j].url == layers[i].url) {
          // todo: free layer
          map.removeLayer(map.layers[j]);
          count_added += 1;
          break;
        }
      }
    }
    if (count_added == 1) {
      alert(Drupal.t('1 layer removed'));
    }
    else if (count_added > 0) {
      alert(Drupal.t('@count layers removed', {'@count': count_added}));
    }
    //map.addLayers(layers);
  }
  else {
    alert(Drupal.t('Map not found'));
  }
}

MappingKit.feedMap = function(feed, id) {
  var url = Drupal.settings.basePath + '?q=' + feed;
  var request = new OpenLayers.Ajax.Request(url, {method: 'get', asynchronous: false, parameters: {'q': feed} });
  var text = '';
  if (request && request.transport && request.transport.status == 200) {
    text = request.transport.responseText;
  }
  else {
    alert('Feed ' + feed + ' returned ' + request.transport.statusText + ' (' + request.transport.status + ')');
    return;
  }
  
  var format = new MappingKit.Format.MapLayerRSS({layerOptions: {isBaseLayer: true, buffer: 0}});
  var layers = format.read(text);
  
  // find map with specific id
  var map = MappingKit.getMap(id);
  if (map) {
    /*
    // remove non-base layers
    for (var i = map.getNumLayers()-1; i > 0; i--) {
      map.removeLayer(map.layers[i]);
    }
    */
    // add new map layers
    var count_added = 0;
    for (var i = 0; i < layers.length; i++) {
      for (var j = 0; j < map.layers.length; j++) {
        if (map.layers[j].name == layers[i].name
          && map.layers[j].url == layers[i].url) {
          break;
        }
      }
      if (j >= map.layers.length) {
        map.addLayer(layers[i]);
        count_added += 1;
      }
    }
    if (count_added == 1) {
      alert(Drupal.t('1 layer added'));
    }
    else if (count_added > 0) {
      alert(Drupal.t('@count layers added', {'@count': count_added}));
    }
    //map.addLayers(layers);
  }
  else {
    alert(Drupal.t('Map not found'));
  }
}

MappingKit.clearMap = function(options) {
  // find map with specific id
  var id = options.id ? options.id : 'tree';
  var map = MappingKit.getMap(id);
  if (map) {
    // remove non-base layers
    for (var i = map.getNumLayers()-1; i > 0; i--) {
      var layer = map.layers[i];
      // remove wms layers that are not base layers
      if (layer instanceof OpenLayers.Layer.WMS && !layer.isBaseLayer) {
        //map.removeLayer(layer, false);
        layer.destroy();
      }
    }
    
    // unset all sub-checkboxes
    $('input#maplayer-check-'+options.term).parent().parent().find('div.maplayer-check > input').each(maplayer_uncheck);
  }
  else {
    alert(Drupal.t('Map not found'));
  }
}

MappingKit.addTerm = function(term, set) {
  var elem = document.getElementById('edit-maplayer-and-terms');
  if (elem) {
    var terms = elem.value == '' ? [] : elem.value.split(',');
    // remove all terms in set
    subtract_arrays(terms, set);
    if (term != '') {
      // check if term is already present
      for (var i = 0; i < terms.length; i++) {
        if (terms[i] == term) {
          return; // term is already present, so no changes
        }
      }
      // add term
      terms.push(term);
    }
    // set form field
    elem.value = terms.join(',');
    //alert(elem.value);
    //alert('term = ' + term + '\nset = ' + set + '\nterms = ' + terms);
  }
}

function subtract_arrays(a1, a2, compareFunction) { 
   if (!compareFunction) compareFunction = null;
   //var a1 = this.removeDuplicates(compareFunction);
   if (!a2 || a2.length == 0) return a1;
   
   //var a2 = a2.removeDuplicates(compareFunction);
   var len2 = a2.length;
   if (compareFunction) {
      for (var i=0;i<a1.length;i++){ 
         var src=a1[i],found=false,src;
         for (var j=0;j<len2&&compareFunction(src2=a2[j],src)!=1;j++) if (compareFunction(src,src2)==0) { found=true; break; } 
         if (found) a1.splice(i--,1);
      } 
   }
   else {
      for (var i = 0; i < a1.length; i++) {
         var src = a1[i], found = false, src2;
         for (var j = 0; j < len2; j++) {
           if (a2[j] == src) {
             // found = true;
             a1.splice(i--, 1);
             break;
           }
         }
         if (found) {
           //a1.splice(i--, 1);
         }
      }
   }
   return a1;
}

