<?php
/**
 * @file
 * Administer mappingkit.
 */

function mappingkit_client_form() {
  $form = array();
  
  return $form;
}

function mappingkit_data_form() {
  $form = array();
  
  return $form;
}

function mappingkit_server_form() {
  $form = array();
  
  return $form;
}

function mappingkit_settings_form() {
  global $db_url;
  
  $help_icon = theme('advanced_help_topic', 'mappingkit', 'general-settings');
  if (!empty($help_icon)) {
    $form['help'] = array('#type' => 'markup'
      , '#value' => '<p>'. theme('advanced_help_topic', 'mappingkit', 'general-settings') . t('Click this icon for help.') .'</p>'
      , '#weight' => -1000
      );
  }
  //drupal_set_message(var_export(theme('advanced_help_topic', 'mappingkit', 'general-settings'), true));
  
  $form['performance'] = array('#type' => 'fieldset'
    , '#title' => t('Performance')
    , '#collapsible' => TRUE
    );
  $form['performance']['mappingkit_add_js_scope'] = array('#type' => 'select'
    , '#title' => t('Loading Javascript files')
    , '#options' => array('header' => t('Head'), 'footer' => t('Bottom'))
    , '#default_value' => variable_get('mappingkit_add_js_scope', DEFAULT_MAPPINGKIT_ADD_JS_SCOPE)
    , '#description' => t('When loading Javascript files in the head section, page rendering is postponed until all files have been loaded.')
    );
  
  $form['tools'] = array('#type' => 'fieldset'
    , '#title' => t('Tools')
    , '#collapsible' => TRUE
    );
  
  $form['tools']['mappingkit_unzip_command'] = array('#type' => 'textfield'
    , '#title' => t('Unzip command')
    , '#default_value' => variable_get('mappingkit_unzip_command', DEFAULT_MAPPINGKIT_UNZIP_COMMAND)
    , '#size' => 100
    );
  
  $form['tools']['mappingkit_zip_command'] = array('#type' => 'textfield'
    , '#title' => t('Zip command')
    , '#default_value' => variable_get('mappingkit_zip_command', DEFAULT_MAPPINGKIT_ZIP_COMMAND)
    , '#size' => 100
    , '#description' => t("Note: the path to the zip executable should not contain spaces and should not have quotes around it. Otherwise geodata exports may fail with a message like 'The system cannot find the path specified'.")
    );
  
  $form['tools']['mappingkit_mapserver_url'] = array('#type' => 'textfield'
    , '#title' => t('Mapserver url')
    , '#default_value' => variable_get('mappingkit_mapserver_url', DEFAULT_MAPPINGKIT_MAPSERVER_URL)
    , '#size' => 100
    );
  $form['tools']['mappingkit_logging'] = array('#type' => 'select'
    , '#title' => t('Logging')
    , '#default_value' => variable_get('mappingkit_logging', Logger::LOG_NONE)
    , '#options' => array(Logger::LOG_NONE => 'none', Logger::LOG_DEBUG => 'debug', Logger::LOG_INFO => 'info')
    , '#description' => t('Logging can also be activated by an url parameter like &amp;log=info')
    );
  
  $form['rss'] = array('#type' => 'fieldset'
    , '#title' => t('RSS')
    , '#collapsible' => TRUE
    );
  
  $form['rss']['mappingkit_rss_enabled'] = array('#type' => 'checkbox'
    , '#title' => t('Enable RSS')
    , '#default_value' => variable_get('mappingkit_rss_enabled', 1)
    );
  
  $form['rss']['mappingkit_rss_version'] = array('#type' => 'select'
    , '#title' => t('RSS version')
    , '#options' => array('simple' => 'Simple', 'gml' => 'GML')
    , '#default_value' => variable_get('mappingkit_rss_version', 'gml')
    );
  
  $form['maps'] = array('#type' => 'fieldset'
    , '#title' => t('Maps')
    , '#collapsible' => TRUE
    , '#description' => t('Default size of maps.')
    );
  $form['maps']['mappingkit_map_width'] = array('#type' => 'textfield'
    , '#title' => t('Width')
    , '#size' => 10
    , '#default_value' => variable_get('mappingkit_map_width', DEFAULT_MAPPINGKIT_MAP_WIDTH)
    , '#prefix' => '<div class="form-inline">'
    );
  $form['maps']['mappingkit_map_height'] = array('#type' => 'textfield'
    , '#title' => t('Height')
    , '#size' => 10
    , '#default_value' => variable_get('mappingkit_map_height', DEFAULT_MAPPINGKIT_MAP_HEIGHT)
    , '#suffix' => '</div><div style="clear: both"/>'
    );
  
  $projections = mappingkit_get_projections();
  $default_value = ''; $sep = '';
  foreach ($projections as $srid => $name) {
    $default_value .= $sep . "$srid=$name";
    $sep = "\n";
  }
  $form['maps']['mappingkit_projections'] = array('#type' => 'textarea'
    , '#title' => t('Projections')
    , '#rows' => 5
    , '#default_value' => variable_get('mappingkit_projections', $default_value)
    , '#description' => t('Enter the available projections as numeric epsg <em>code=description</em>, e.g. 4326=lat/lon. Each projection on a separate line.')
    );
  /*
  $form['base'] = array('#type' => 'fieldset'
    , '#title' => t('Background layers')
    , '#collapsible' => TRUE
    );
  */
  
  $php_os = strtolower(PHP_OS);
  if ($php_os == 'linux' || $php_os == 'unix') {
    
    $form[$php_os] = array('#type' => 'fieldset'
      , '#title' => ucfirst($php_os)
      , '#collapsible' => TRUE
      );
    
    $form[$php_os]['mappingkit_chmod_files'] = array('#type' => 'textfield'
      , '#title' => t('chmod parameter')
      , '#description' => t("Parameter to use for chmod'ing files in the temporary folder, e.g. pdf maps or context documents. If uncertain, leave this field empty. When not able to view pdf maps, you may want to try 0644.")
      , '#default_value' => variable_get('mappingkit_chmod_files', DEFAULT_MAPPINGKIT_CHMOD_FILES)
      );
  }
  
  $form['#validate'][] = 'mappingkit_settings_validate';
  
  return system_settings_form($form);
}

function mappingkit_settings_validate(&$form, &$form_state) {
  // empty mappingkit_projections cache
  cache_clear_all('mappingkit_projections', 'cache');
}

