<?php

/**
 * @file
 * Page callback file for the mappingkit module.
 */

/**
 * Menu callback; displays a Drupal page containing recent wms nodes of a given user.
 */
function mappingkit_page_user($type, $account) {
  //drupal_set_message(var_export($account,true));
  global $user;

  //$account = user_load(array((is_numeric($uid) ? 'uid' : 'name') => $uid, 'status' => 1));

  $types = node_get_types('types');
  $type_info = $types[$type];
  if (!empty($account->uid)) {
    drupal_set_title($title = t("@name's {$type_info->name}", array('@name' => $account->name)));

    $items = array();
    if (($account->uid == $user->uid) && user_access("create $type")) {
      $items[] = l(t('Post a new @name.', array('@name' => $type_info->name)), "node/add/$type");
    }
    else if ($account->uid == $user->uid) {
      $items[] = t('You are not allowed to post a new @name.', array('@name' => $type_info->name)) .'</li>';
    }

    $output = theme('item_list', $items);
    
    $result = pager_query(db_rewrite_sql("SELECT n.nid, n.sticky, n.created FROM {node} n WHERE n.type = '$type' AND n.uid = %d AND n.status = 1 ORDER BY n.sticky DESC, n.created DESC"), variable_get('default_nodes_main', 10), 0, NULL, $account->uid);
    while ($node = db_fetch_object($result)) {
      $output .= node_view(node_load($node->nid), 1);
    }
    $output .= theme('pager', NULL, variable_get('default_nodes_main', 10));
    drupal_add_feed(url($type .'/'. $account->uid .'/feed'), t('RSS - !title', array('!title' => $title)));

    return $output;
  }
  else {
    drupal_not_found();
  }
}

/**
 * Menu callback; displays a Drupal page containing recent Web Mapping Services of all users.
 */
function mappingkit_page_last($type) {
  global $user;

  $types = node_get_types('types');
  $type_info = $types[$type];
  
  $output = '';

  $result = pager_query(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = '$type' AND n.status = 1 ORDER BY n.sticky DESC, n.created DESC"), variable_get('default_nodes_main', 10));

  while ($node = db_fetch_object($result)) {
    $output .= node_view(node_load($node->nid), 1);
  }
  $output .= theme('pager', NULL, variable_get('default_nodes_main', 10));
  drupal_add_feed(url("$type/feed"), t('RSS - %name', array('%name' => $type_info->name)));

  return $output;
}

/**
 * Menu callback; displays an RSS feed containing recent WMS entries of a given user.
 */
function mappingkit_feed_user($type, $account) {
  $types = node_get_types('types');
  $type_info = $types[$type];
  
  $result = db_query_range(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = '$type' AND n.uid = %d AND n.status = 1 ORDER BY n.created DESC")
    , $account->uid, 0, variable_get('feed_default_items', 10));
  $channel['title'] = $account->name ."'s {$type_info->name} ";// . var_export($account, true);
  $channel['link'] = url("$type/{$account->uid}", array('absolute' => TRUE));

  $items = array();
  while ($row = db_fetch_object($result)) {
    $items[] = $row->nid;
  }
  node_feed($items, $channel);
}

/**
 * Menu callback; displays an RSS feed containing recent WMS entries of all users.
 */
function mappingkit_feed_last($type) {
  $types = node_get_types('types');
  $type_info = $types[$type];
  
  $result = db_query_range(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = '$type' AND n.status = 1 ORDER BY n.created DESC")
    , 0, variable_get('feed_default_items', 10));
  $channel['title'] = variable_get('site_name', 'Drupal') .' '. $type_info->name;
  $channel['link'] = url($type, array('absolute' => TRUE));

  while ($row = db_fetch_object($result)) {
    $items[] = $row->nid;
  }
  node_feed($items, $channel);
}

