<?php

function mapserver_settings_fonts_form() {
  $form = array();
  
  $form['fonts'] = array('#type' => 'fieldset'
    , '#title' => t('Fonts')
    , '#collapsible' => TRUE
    );
  
  $form['fonts']['mappingkit_font_folders'] = array('#type' => 'textarea'
    , '#title' => t('Font folders')
    , '#rows' => 3
    , '#default_value' => variable_get('mappingkit_font_folders', DEFAULT_MAPPINGKIT_FONT_FOLDERS)
    , '#description' => t('Enter folders containing truetype fonts.')
    );
  
  $font_options = array();
  $folders = explode("\n", variable_get('mappingkit_font_folders', DEFAULT_MAPPINGKIT_FONT_FOLDERS));
  foreach ($folders as $folder) {
    if (is_dir($folder)) {
      foreach (glob($folder .'/*.ttf') as $filename) {
        $font_options[$filename] = basename($filename, '.ttf');
      }
    }
  }
  
  $form['fonts']['mappingkit_get_fonts'] = array('#type' => 'submit'
    , '#value' => t('Get fonts')
    );
  
  $form['fonts']['mappingkit_font_mono'] = array('#type' => 'select'
    , '#title' => t('Monospaced font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_mono', '')
    );
  
  $form['fonts']['mappingkit_font_sans'] = array('#type' => 'select'
    , '#title' => t('Sans serif font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_sans', '')
    );
  
  $form['fonts']['mappingkit_font_serif'] = array('#type' => 'select'
    , '#title' => t('Serif font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_serif', '')
    );
  
  $form['fonts']['mappingkit_font_italic'] = array('#type' => 'select'
    , '#title' => t('Italic font')
    , '#options' => $font_options
    , '#default_value' => variable_get('mappingkit_font_italic', '')
    );
  
  $form['fontset'] = array('#type' => 'fieldset'
    , '#title' => t('Fontset file')
    , '#collapsible' => TRUE
    );
  $form['fontset']['mapserver_fontset'] = array('#type' => 'textfield'
    , '#title' => t('File name')
    , '#default_value' => variable_get('mapserver_fontset', 'fontset.txt')
    );
  $form['fontset']['mappingkit_write_fonts'] = array('#type' => 'submit'
    , '#value' => t('Write font file')
    , '#description' => t('A fontset file will be written to the files folder.')
    );
  
  $form['#validate'][] = 'mapserver_settings_fonts_validate';
  
  return system_settings_form($form);
}

function mapserver_settings_fonts_validate(&$form, &$form_state) {
  if ($form_state['values']['op'] == t('Write font file')) {
    $path = file_directory_path() .'/fontset.txt';
    
    $content = 'mono '. $form_state['values']['mappingkit_font_mono'] ."\n";
    $content .= 'sans '. $form_state['values']['mappingkit_font_sans'] ."\n";
    $content .= 'serif '. $form_state['values']['mappingkit_font_serif'] ."\n";
    $content .= 'italic '. $form_state['values']['mappingkit_font_italic'] ."\n";
    file_put_contents($path, $content);
    
    global $_mappingkit_logger;
    $_mappingkit_logger->debug($content);
    
    drupal_set_message(t('Font file %file has been created.', array('%file' => $path)));
  }
}

