<?php

function mapserver_settings_symbols_form() {
  $form = array();
  
  $map_path = mapserver_get_real_path('dummy.map');
  $symbolset_path = mapserver_get_real_path('mapserver-symbols.sym');
  if (!file_exists($map_path)) {
    // create empty symbol file
    file_put_contents($symbolset_path, '
SYMBOL
  NAME circle
  TYPE ELLIPSE
  FILLED TRUE
  POINTS
    1 1
  END
END
');
    
    $oMap = ms_newMapObj(NULL);
    $oMap->setExtent(-180, -90, 180, 90);
    $oMap->save($map_path);
    $oMap = NULL;
  }
  else {
    drupal_set_message(t("$map_path exists"));
  }
  
  //$oMap = ms_newMapObj($map_path);
  $oMap = ms_newMapObj($map_path);
  if (! $oMap) {
    drupal_set_message(t('Error opening map file.'));
    unlink($map_path);
    return $form;
  }
  
  $oMap->setSymbolSet($symbolset_path);
  
  // create default symbols
  $id = ms_newSymbolObj($oMap, 'circle');
  $oSymbol = $oMap->getSymbolObjectById($id);
  $oSymbol->set("filled", MS_TRUE);
  $oSymbol->set("sizex", 1);
  $oSymbol->set("sizey", 1);
  $oSymbol->set("inmapfile", MS_TRUE);
  
  // symbol of type VECTOR or ELLIPSE must have point data
  $aPoints[0] = 2;
  $aPoints[1] = 2;
  $oSymbol->setpoints($aPoints);

  $aStyle[0] = 10;
  $aStyle[1] = 5;
  $aStyle[2] = 5;
  $aStyle[3] = 10;
  $oSymbol->setstyle($aStyle);
  
  $oMap->save($map_path);
  $oMap = NULL;
  
  return system_settings_form($form);
}

