
/**
 * Class: OpenLayers.Control.ContextSwitcher
 *
 * Inherits from:
 *  - <OpenLayers.Control>
 */
OpenLayers.Control.ContextSwitcher = 
    OpenLayers.Class(OpenLayers.Control, {
    
    // todo: properties
    
    /**
     * Constructor: OpenLayers.Control.LayerSwitcher
     * 
     * Parameters:
     * options - {Object}
     */
    initialize: function(options) {
        OpenLayers.Control.prototype.initialize.apply(this, arguments);
        
        // todo: my own initializations
    },

    /**
     * APIMethod: destroy 
     */    
    destroy: function() {
        // todo: my own destructions
        
        OpenLayers.Control.prototype.destroy.apply(this, arguments);
    },

    CLASS_NAME: "OpenLayers.Control.ContextSwitcher"
});

function switchContext(path) {
  var wmc_options = {'layerOptions': {buffer: 0}};
  
  map = maps[0];
  if (path == 'node/4/context') {
    wmc_options.layerOptions.units = 'm';
    wmc_options.layerOptions.maxResolution = 2000/512;
    
    map.projection = new OpenLayers.Projection('EPSG:28992');
    map.maxExtent = new OpenLayers.Bounds(131000, 480000, 133000, 481000);
  }
  else {
    wmc_options.layerOptions.units = 'degrees';
    wmc_options.layerOptions.maxResolution = 360/512;
    
    map.projection = new OpenLayers.Projection('EPSG:4326');
    map.maxExtent = new OpenLayers.Bounds(-180, -90, 180, 90);
  }
  
  var wmc = new OpenLayers.Format.WMC(wmc_options);
  
  var request = new OpenLayers.Ajax.Request(Drupal.settings.basePath, {method: 'get', asynchronous: false, parameters: {q: path} });
  var text = '';
  if (request && request.transport) {
    text = request.transport.responseText;
  }
  //maps[0].destroy(); // replace previous map
  
  // remove previous layers
  if (map.layers != null) {
    for (var i = map.layers.length - 1; i>=0; --i) {
      // pass 'false' to destroy so that map wont try to set a new 
      // baselayer after each baselayer is removed
      map.layers[i].destroy(false);
    } 
    map.layers = [];
  }
  
  //alert(text);
  map = wmc.read(text, {'map': map});
  map.zoomToMaxExtent();
}

