
MappingKit.Control.MapContext = OpenLayers.Class(OpenLayers.Control, {
  /**
   * Property: type
   * TYPE_BUTTON.
   */
  type: OpenLayers.Control.TYPE_BUTTON,
  
  /*
   * Method: trigger
   * Return web map context.
   */
  trigger: function() {
    if (this.map) {
      var wmc_options = {'layerOptions': {buffer: 0}};
      var wmc = new OpenLayers.Format.MapContext(wmc_options);
      var uri = '';
      if (!this.map.title) {
        this.map.title = Drupal.t('Unknown');
      }
      try {
        var text = wmc.write(this.map, {});
        
        // write text to local file
        if (!MappingKit.settings.fileDirectoryTemp) {
          alert(Drupal.t('The temporary directory of this site is not accessible.'));
        }
        else {
          uri = Drupal.settings.basePath +  MappingKit.settings.basePath + '/serializer.php?'
            + 'file_directory_temp=' + MappingKit.settings.fileDirectoryTemp
            + '&base_path=' + Drupal.settings.basePath;
          if (MappingKit.settings.fileMode) {
            uri += '&file_mode=' + MappingKit.settings.fileMode;
          }
          jQuery.post(uri, {postBody: text}
            , function(response) {
                data = Drupal.parseJson(response);
                window.open(data.fileUrl, 'WMC');
              });
        }
      }
      catch (err) {
        alert('wmc error: ' + err.message + '\nuri: ' + uri);
      }
    }
  },

  CLASS_NAME: "mk.Control.MapContext"
});

