
/**
 * Class: OpenLayers.Control.MapProjection
 *
 * Inherits from:
 *  - <OpenLayers.Control>
 */
OpenLayers.Control.MapProjection = 
    OpenLayers.Class(OpenLayers.Control, {
    
    // todo: properties
    displayProjection: null,
    
    /**
     * Constructor: OpenLayers.Control.MapProjection
     * 
     * Parameters:
     * options - {Object}
     */
    initialize: function(options) {
        OpenLayers.Control.prototype.initialize.apply(this, arguments);
        
        // todo: my own initializations
        //if (options.displayProjection) {
        //  this.displayProjection = options.displayProjection;
        //}
    },

    draw: function() {
      OpenLayers.Control.prototype.draw.apply(this, arguments);
      
      this.redraw();
      return this.div;
    },
    
    redraw: function(evt) {
      if (this.displayProjection) {
        this.div.innerHTML = this.displayProjection;
      }
      else {
        this.div.innerHTML = $defined(this.map.displayProjection)
          ? this.map.displayProjection : this.map.projection;
      }
    },
    
    setMap: function() {
      OpenLayers.Control.prototype.setMap.apply(this, arguments);
      this.map.events.register('changebaselayer', this, this.redraw);
    },
    
    /**
     * APIMethod: destroy 
     */    
    destroy: function() {
        // todo: my own destructions
        
        OpenLayers.Control.prototype.destroy.apply(this, arguments);
    },

    CLASS_NAME: "OpenLayers.Control.MapProjection"
});

