
MappingKit.MapClient.OpenLayers = {
  
  /**
   * Property: maps
   */
  maps: null,
  
  /**
   * Register id with OpenLayers map object.
   */
  registerMap: function(id, map) {
    if (!this.maps) {
      this.maps = {};
    }
    this.maps[id] = map;
  },
  
  /**
   * Get map object for given map id.
   */
  getMapObject: function(id) {
    return this.maps[id];
  },
  
  /**
   * (MapClient interface function)
   * @param extent
   *   Extent as a comma-separated string of minx,miny,maxx,maxy.
   */
  zoomToExtent: function(id, extent) {
    if (this.maps[id]) {
      this.maps[id].zoomToExtent(OpenLayers.Bounds.fromString(extent));
    }
  },
  
  CLASS_NAME: 'MappingKit.MapClient.OpenLayers'
};

