<?php

/**
 * Script to write incoming data to a (temporary) file and return a
 * (relative) web path to it.
 */

// Set save directory.  This should be set to a writable, web-accessible 
// directory, relative to the drupal installation

$base_path = $_GET['base_path'];
$file_directory_temp = $_GET['file_directory_temp'];
$file_mode = $_GET['file_mode'];

// remove base_path from this script_filename
$script_name = substr($_SERVER['SCRIPT_NAME'], strlen($base_path));
$temp_filepath = str_replace($script_name, $file_directory_temp, str_replace("\\", "/", $_SERVER['SCRIPT_FILENAME'])) . '/';
$temp_webpath = $base_path . $file_directory_temp . '/';

// Read in data.
// Note: $_POST['postBody'] seems to give backslashes before double quotes in xml
// under windows.
//$data = $_POST['postBody'];

$raw_data = file_get_contents("php://input"); // raw post
$raw_params = explode('&', $raw_data);
$params = array();
foreach ($raw_params as $param) {
  $parts = explode('=', $param, 2);
  $params[$parts[0]] = urldecode($parts[1]);
}
$data = $params['postBody'];

// Create temp file
$tmpfname = tempnam($temp_filepath, "dmk");

// save data to it
$handle = fopen($tmpfname, "wb");
fwrite($handle, $data);
fclose($handle);

if (!empty($file_mode)) {
  // set file mode (linux)
  chmod($tmpfname, intval($file_mode, 8));
}

// rename to .xml
$ext = '.'. (isset($_GET['ext']) ? $_GET['ext'] : 'xml');
if (rename($tmpfname, $tmpfname . $ext)) {
  $tmpfname .= $ext;
}

if (isset($_GET['format']) && $_GET['format'] == 'xml') {
  // Send xml content type header.
  header("Content-type: text/xml");
  
  // Return fileUrl in XML
  echo '
  <XmlSerializer xmlns:xlink="http://www.w3.org/1999/xlink">
    <OnlineResource xlink:type="simple" xlink:href="' 
    . $temp_webpath . basename($tmpfname)
    . '"/>
  </XmlSerializer>';
}
else {
  // Send text content type header.
  header("Content-type: text/plain");
  
  // return json fileUrl
  echo '{ fileUrl: "'. $temp_webpath . basename($tmpfname) .'"}';
}

