<?php

/**
 * @file
 * Page callback file for the wms module.
 */

/**
 * Menu callback; displays a Drupal page containing recent wms nodes of a given user.
 */
function wms_page_user($account) {
  //drupal_set_message(var_export($account,true));
  global $user;

  //$account = user_load(array((is_numeric($uid) ? 'uid' : 'name') => $uid, 'status' => 1));

  if (!empty($account->uid)) {
    drupal_set_title($title = t("@name's Web Mapping Services", array('@name' => $account->name)));

    $items = array();
    if (($account->uid == $user->uid) && user_access('create wms')) {
      $items[] = l(t('Post a new Web Mapping Service.'), "node/add/wms");
    }
    else if ($account->uid == $user->uid) {
      $items[] = t('You are not allowed to post a new Web Mapping Service.') .'</li>';
    }

    $output = theme('item_list', $items);
    
    $result = pager_query(db_rewrite_sql("SELECT n.nid, n.sticky, n.created FROM {node} n WHERE n.type = 'wms' AND n.uid = %d AND n.status = 1 ORDER BY n.sticky DESC, n.created DESC"), variable_get('default_nodes_main', 10), 0, NULL, $account->uid);
    while ($node = db_fetch_object($result)) {
      $output .= node_view(node_load($node->nid), 1);
    }
    $output .= theme('pager', NULL, variable_get('default_nodes_main', 10));
    drupal_add_feed(url('wms/'. $account->uid .'/feed'), t('RSS - !title', array('!title' => $title)));

    return $output;
  }
  else {
    drupal_not_found();
  }
}

/**
 * Menu callback; displays a Drupal page containing recent Web Mapping Services of all users.
 */
function wms_page_last() {
  global $user;

  $output = '';

  $result = pager_query(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = 'wms' AND n.status = 1 ORDER BY n.sticky DESC, n.created DESC"), variable_get('default_nodes_main', 10));

  while ($node = db_fetch_object($result)) {
    $output .= node_view(node_load($node->nid), 1);
  }
  $output .= theme('pager', NULL, variable_get('default_nodes_main', 10));
  drupal_add_feed(url('wms/feed'), t('RSS - Web Mapping Services'));

  return $output;
}

/**
 * Menu callback; displays an RSS feed containing recent WMS entries of a given user.
 */
function wms_feed_user($account) {
  $result = db_query_range(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = 'wms' AND n.uid = %d AND n.status = 1 ORDER BY n.created DESC")
    , $account->uid, 0, variable_get('feed_default_items', 10));
  $channel['title'] = $account->name ."'s Web Mapping Services ";// . var_export($account, true);
  $channel['link'] = url("wms/{$account->uid}", array('absolute' => TRUE));

  $items = array();
  while ($row = db_fetch_object($result)) {
    $items[] = $row->nid;
  }
  node_feed($items, $channel);
}

/**
 * Menu callback; displays an RSS feed containing recent WMS entries of all users.
 */
function wms_feed_last() {
  $result = db_query_range(db_rewrite_sql("SELECT n.nid, n.created FROM {node} n WHERE n.type = 'wms' AND n.status = 1 ORDER BY n.created DESC")
    , 0, variable_get('feed_default_items', 10));
  $channel['title'] = variable_get('site_name', 'Drupal') .' Web Mapping Services';
  $channel['link'] = url('wms', array('absolute' => TRUE));

  while ($row = db_fetch_object($result)) {
    $items[] = $row->nid;
  }
  node_feed($items, $channel);
}

